unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    lbLog: TListBox;
    Panel1: TPanel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    procedure ReadHIDReports(HidName : String);
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Uses SetupApi, Hid;

//   HID-
//   
procedure TForm1.Button1Click(Sender: TObject);
var HidGuid : TGuid; PnPHandle : HDevInfo;
    DevData: TSPDevInfoData;
    DeviceInterfaceData: TSPDeviceInterfaceData;
    FunctionClassDeviceData: PSPDeviceInterfaceDetailData;
    Success: LongBool;
    DevIndex: DWORD;
    BytesReturned: DWORD;
    HidName : String;
begin
 //  
 lbLog.Items.Clear;
 //  GUID   HID
 HidD_GetHidGuid(HidGuid);
 //   PnP  HID-
 PnPHandle := SetupDiGetClassDevs(@HidGuid, nil, 0, DIGCF_PRESENT or DIGCF_DEVICEINTERFACE);
 //  ,  
 If PnPHandle = Pointer(INVALID_HANDLE_VALUE) then Exit;
 
 Try
  //   
  DevIndex := 0;
  //      HID-
  Repeat
   DeviceInterfaceData.cbSize := SizeOf(TSPDeviceInterfaceData);

   //       DevIndex
   Success := SetupDiEnumDeviceInterfaces(PnPHandle, nil, HidGuid, DevIndex, DeviceInterfaceData);
   If Success then begin
    DevData.cbSize := SizeOf(DevData);
    BytesReturned  := 0;
    //       DeviceInterfaceData
    //      ,   
    // ,   ,   
    SetupDiGetDeviceInterfaceDetail(PnPHandle, @DeviceInterfaceData, nil, 0, BytesReturned, @DevData);
    If (BytesReturned <> 0) and (GetLastError = ERROR_INSUFFICIENT_BUFFER) then begin
     //  
     FunctionClassDeviceData := AllocMem(BytesReturned);
     FunctionClassDeviceData.cbSize := 5;
     //  
     If SetupDiGetDeviceInterfaceDetail(PnPHandle, @DeviceInterfaceData, FunctionClassDeviceData, BytesReturned, BytesReturned, @DevData) then begin
      //   PnP- 
      HidName:= StrPas(PChar(@FunctionClassDeviceData.DevicePath));
      lbLog.Items.Add(HidName);
      //  
      ReadHIDReports(HidName);
     End;
     //  
     FreeMem(FunctionClassDeviceData);
    End;
   End;
   //  
   Inc(DevIndex);
  Until not Success;
 Finally
  SetupDiDestroyDeviceInfoList(PnPHandle);
 End;
end;

//  
procedure TForm1.ReadHIDReports(HidName : String);
var HidHandle : THandle;
    CanReadWriteAccess : Boolean;
    Attributes : THIDDAttributes;
    NumInputBuffers : Integer;
    Buffer  : array [0..253] of WideChar;
    InputReport : Array [0..255] of Byte;
    i : Integer; S : String;
    BytesRead : Cardinal;
    Capabilities : HIDP_CAPS;
    PreparsedData: PHIDPPreparsedData;
    ReadOL : TOverLapped; {   }
    ReadFlag : Boolean;

    //    
    Function GetString(StrDescriptor : Byte): WideString;
    var Buffer : array [0..253] of WideChar;
    begin
     Result := '';
     if StrDescriptor <> 0 then
      if HidD_GetIndexedString(HidHandle, StrDescriptor, Buffer, SizeOf(Buffer)) then
       Result:= Buffer;
    end;

begin
 //    
 //   r/w
 lbLog.Items.Add('   HID-...');
 HidHandle:= CreateFile(PChar(@HidName[1]),
              GENERIC_READ or GENERIC_WRITE,
              FILE_SHARE_READ or FILE_SHARE_WRITE,
              nil,
              OPEN_EXISTING,
              FILE_FLAG_OVERLAPPED,
              0
 );

 //   ?
 CanReadWriteAccess:= HidHandle <> INVALID_HANDLE_VALUE;

 //   ,  
 //     
 If not CanReadWriteAccess then begin
  HidHandle:= CreateFile(PChar(@HidName[1]),
               0,
               FILE_SHARE_READ or FILE_SHARE_WRITE,
               nil,
               OPEN_EXISTING,
               FILE_FLAG_OVERLAPPED,
               0
  );
 End else begin
  lbLog.Items.Add('     read/write');
 End;

 //    -   
 If HidHandle = INVALID_HANDLE_VALUE then begin
  lbLog.Items.Add('   ');
  Exit;
 End else begin
  lbLog.Items.Add('     read only!');
 End;

 //   
 Attributes.Size := SizeOf(THIDDAttributes);
 If HidD_GetAttributes(HidHandle, Attributes) then begin
  lbLog.Items.Add(Format('   VendorID=%d, ProductID=%d, VersionNumber=%d',[Attributes.VendorID, Attributes.ProductID, Attributes.VersionNumber]));
 End else begin
  lbLog.Items.Add('  HidD_GetAttributes');
 End;

 //   
 If HidD_GetNumInputBuffers(HidHandle, NumInputBuffers) then begin
  lbLog.Items.Add(Format('     =%d',[NumInputBuffers]));
 End else begin
  lbLog.Items.Add('  HidD_GetNumInputBuffers');
 End;

 //   
 FillChar(Buffer, SizeOf(Buffer), #0);
 If HidD_GetManufacturerString(HidHandle, Buffer, SizeOf(Buffer)) then begin
  lbLog.Items.Add(Format('   =%s',[Buffer]));
 End else begin
  lbLog.Items.Add('  HidD_GetManufacturerString');
 End;

 //   
 FillChar(Buffer, SizeOf(Buffer), #0);
 If HidD_GetProductString(HidHandle, Buffer, SizeOf(Buffer)) then begin
  lbLog.Items.Add(Format('   =%s',[Buffer]));
 End else begin
  lbLog.Items.Add('  HidD_GetProductString');
 End;

 //   
 FillChar(Buffer, SizeOf(Buffer), #0);
 If HidD_GetSerialNumberString(HidHandle, Buffer, SizeOf(Buffer)) then begin
  lbLog.Items.Add(Format('    =%s',[Buffer]));
 End else begin
  lbLog.Items.Add('  HidD_GetSerialNumberString');
 End;

 If HidD_GetPreparsedData(HidHandle, PreparsedData) then begin
  HidP_GetCaps(PreparsedData, Capabilities);
  lbLog.Items.Add(Format(' UsagePage              =%x',[Capabilities.UsagePage              ]));
  lbLog.Items.Add(Format(' InputReportByteLength  =%d',[Capabilities.InputReportByteLength  ]));
  lbLog.Items.Add(Format(' OutputReportByteLength =%d',[Capabilities.OutputReportByteLength ]));
  lbLog.Items.Add(Format(' FeatureReportByteLength=%d',[Capabilities.FeatureReportByteLength]));
 End else begin
  lbLog.Items.Add('  HidD_GetPreparsedData');
 End;

{
 FillChar(InputReport, SizeOf(InputReport), #0);
 InputReport[0]:= 0;
 If HidD_GetInputReport(HidHandle, @InputReport, 9) then begin
  S:= '';
  For i:= 1 to 9 do begin
   S:= S + ' ' + IntToHex(InputReport[i], 2);
  End;
  lbLog.Items.Add(' :' + S);
 End else begin
  lbLog.Items.Add('  HidD_GetInputReport ('+SysErrorMessage(GetLastError)+')');
 End;
{}


 If Capabilities.FeatureReportByteLength > 0 then begin
  FillChar(InputReport, SizeOf(InputReport), #0);
  // InputReport[1]:= 1;
  If HidD_GetFeature(HidHandle, InputReport, Capabilities.FeatureReportByteLength) then begin
   S:= '';
   For i:= 0 to Capabilities.FeatureReportByteLength-1 do begin
    S:= S + ' ' + IntToHex(InputReport[i], 2);
   End;
   lbLog.Items.Add(' :' + S);
  End else begin
   lbLog.Items.Add('  HidD_GetFeature ('+SysErrorMessage(GetLastError)+')');
  End;
 End else begin
  lbLog.Items.Add(' FeatureReport  ');
 End;

 If Capabilities.InputReportByteLength > 0 then begin
  FillChar(InputReport, SizeOf(InputReport), #0);

  {    }
  FillChar(ReadOL, SizeOf(ReadOL), 0);
  ReadOL.hEvent:= CreateEvent(nil, True, True, nil);

  ReadFlag:= False;
  If not ReadFile(HidHandle, InputReport, Capabilities.InputReportByteLength, BytesRead, @ReadOL) then begin
   If GetLastError() = ERROR_IO_PENDING then begin
    If WaitForSingleObject(ReadOL.hEvent, 2000) = WAIT_OBJECT_0 then
     ReadFlag:= True;
   End else begin
    lbLog.Items.Add('  ReadFile');
   End;
  End else begin
   ReadFlag:= True;
  End;

  If ReadFlag then begin
   S:= '';
   For i:= 0 to BytesRead-1 do begin
    S:= S + ' ' + IntToHex(InputReport[i], 2);
   End;
   lbLog.Items.Add(' :' + S);
  End else begin
   lbLog.Items.Add('    ');
  End;

  CloseHandle(ReadOL.hEvent);
 End else begin
  lbLog.Items.Add(' InputReport  ');
 End;

 //   PreparsedData
 HidD_FreePreparsedData(PreparsedData);
 //   
 CloseHandle(HidHandle);
end;

end.
 