// ATDriver.cpp
//
// Generated by DriverWizard version DriverStudio 2.6.0 (Build 336)
// Requires Compuware's DriverWorks classes
//

#define VDW_MAIN
#include <vdw.h>
#include <kusb.h>
#include "ATDriver.h"
#include "ATDriverDevice.h"

#pragma hdrstop("ATDriver.pch")

// Generated by DriverWizard version DriverStudio 2.6.0 (Build 336)

// Set a default 32-bit tag value to be stored with each heap block
// allocated by operator new. Use BoundsChecker to view the memory pool.
// This value can be overridden using the global function SetPoolTag().
POOLTAG DefaultPoolTag('rDTA');

/////////////////////////////////////////////////////////////////////
// Begin INIT section
#pragma code_seg("INIT")

DECLARE_DRIVER_CLASS(ATDriver, NULL)

/////////////////////////////////////////////////////////////////////
//  ATDriver::DriverEntry
//
//	Routine Description:
//		This is the first entry point called by the system when the
//		driver is loaded.
// 
//	Parameters:
//		RegistryPath - String used to find driver parameters in the
//			registry.  To locate ATDriver look for:
//			HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\ATDriver
//
//	Return Value:
//		NTSTATUS - Return STATUS_SUCCESS if no errors are encountered.
//			Any other indicates to the system that an error has occured.
//
//	Comments:
//

NTSTATUS ATDriver::DriverEntry(PUNICODE_STRING RegistryPath)
{

 	DbgPrint("ATDriver::DriverEntry START");
	m_Unit = 0;
 	DbgPrint("ATDriver::DriverEntry END");
	return STATUS_SUCCESS;
}

// End INIT section
/////////////////////////////////////////////////////////////////////
#pragma code_seg()

/////////////////////////////////////////////////////////////////////
//  ATDriver::AddDevice
//
//	Routine Description:
//		Called when the system detects a device for which this
//		driver is responsible.
//
//	Parameters:
//		Pdo - Physical Device Object. This is a pointer to a system device
//			object that represents the physical device.
//
//	Return Value:
//		NTSTATUS - Success or failure code.
//
//	Comments:
//		This function creates the Functional Device Object, or FDO. The FDO
//		enables this driver to handle requests for the physical device. 
//

NTSTATUS ATDriver::AddDevice(PDEVICE_OBJECT Pdo)
{

	DbgPrint("ATDriver::AddDevice START");

    	// Create the device object. Note that we used a form of "placement" new,
	// that is a member operator of KDevice.  This form will use storage
	// allocated by the system in the device object's device to store our
	// class instance.
	ATDriverDevice * pDevice = new (
			static_cast<PCWSTR>(KUnitizedName(L"ATDriverDevice", m_Unit)),
			FILE_DEVICE_UNKNOWN,
			static_cast<PCWSTR>(KUnitizedName(L"ATDriverDevice", m_Unit)), 
			0,
			DO_BUFFERED_IO
		)
		ATDriverDevice(Pdo, m_Unit);

	if (pDevice == NULL)
	{
	    DbgPrint("Error creating pDevice");
	    return STATUS_INSUFFICIENT_RESOURCES;
	}

	NTSTATUS status = pDevice->ConstructorStatus();

	if ( !NT_SUCCESS(status) )
	{
	        DbgPrint("Error pDevice->ConstructorStatus");
		delete pDevice;
	}
	else
	{
		m_Unit++;
	        DbgPrint("Unit number is %d", m_Unit);
	}

	DbgPrint("ATDriver::AddDevice END");
	return status;
}
