unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    lbLog: TListBox;
    Panel1: TPanel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    procedure DisplayHIDInformation(HidName : String);
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Uses SetupApi, Hid;

Type
 THidDescriptorList = packed record
  bReportType   : BYTE;
  wReportLength : WORD;
 End;

 TUsbHidDescriptor = packed record
  bLength         : BYTE;
  bDescriptorType : BYTE;
  bcdHID          : WORD;
  bCountryCode    : BYTE;
  bNumDescriptors : BYTE;
  DescriptorList  : Array of THidDescriptorList;
 End;


//   HID-
//   
procedure TForm1.Button1Click(Sender: TObject);
var HidGuid : TGuid; PnPHandle : HDevInfo;
    DevData: TSPDevInfoData;
    DeviceInterfaceData: TSPDeviceInterfaceData;
    FunctionClassDeviceData: PSPDeviceInterfaceDetailData;
    Success: LongBool;
    DevIndex: DWORD;
    BytesReturned: DWORD;
    HidName : String;
begin
 //  
 lbLog.Items.Clear;
 //  GUID   HID
 HidD_GetHidGuid(HidGuid);
 //   PnP  HID-
 PnPHandle := SetupDiGetClassDevs(@HidGuid, nil, 0, DIGCF_PRESENT or DIGCF_DEVICEINTERFACE);
 //  ,  
 If PnPHandle = Pointer(INVALID_HANDLE_VALUE) then Exit;
 
 Try
  //   
  DevIndex := 0;
  //      HID-
  Repeat
   DeviceInterfaceData.cbSize := SizeOf(TSPDeviceInterfaceData);

   //       DevIndex
   Success := SetupDiEnumDeviceInterfaces(PnPHandle, nil, HidGuid, DevIndex, DeviceInterfaceData);
   If Success then begin
    DevData.cbSize := SizeOf(DevData);
    BytesReturned  := 0;
    //       DeviceInterfaceData
    //      ,   
    // ,   ,   
    SetupDiGetDeviceInterfaceDetail(PnPHandle, @DeviceInterfaceData, nil, 0, BytesReturned, @DevData);
    If (BytesReturned <> 0) and (GetLastError = ERROR_INSUFFICIENT_BUFFER) then begin
     //  
     FunctionClassDeviceData := AllocMem(BytesReturned);
     FunctionClassDeviceData.cbSize := 5;
     //  
     If SetupDiGetDeviceInterfaceDetail(PnPHandle, @DeviceInterfaceData, FunctionClassDeviceData, BytesReturned, BytesReturned, @DevData) then begin
      //   PnP- 
      HidName:= StrPas(PChar(@FunctionClassDeviceData.DevicePath));
      lbLog.Items.Add(HidName);
      //    
      DisplayHIDInformation(HidName);
     End;
     //  
     FreeMem(FunctionClassDeviceData);
    End;
   End;
   //  
   Inc(DevIndex);
  Until not Success;
 Finally
  SetupDiDestroyDeviceInfoList(PnPHandle);
 End;
end;

//    HID-
procedure TForm1.DisplayHIDInformation(HidName : String);
var HidHandle : THandle;
    CanReadWriteAccess : Boolean;
    Attributes : THIDDAttributes;
    NumInputBuffers : Integer;
    Buffer  : array [0..253] of WideChar;

    //    
    Function GetString(StrDescriptor : Byte): WideString;
    var Buffer : array [0..253] of WideChar;
    begin
     Result := '';
     if StrDescriptor <> 0 then
      if HidD_GetIndexedString(HidHandle, StrDescriptor, Buffer, SizeOf(Buffer)) then
       Result:= Buffer;
    end;

begin
 //    
 //   r/w
 lbLog.Items.Add('   HID-...');
 HidHandle:= CreateFile(PChar(@HidName[1]),
              GENERIC_READ or GENERIC_WRITE,
              FILE_SHARE_READ or FILE_SHARE_WRITE,
              nil,
              OPEN_EXISTING, 0, 0
 );

 //   ?
 CanReadWriteAccess:= HidHandle <> INVALID_HANDLE_VALUE;

 //   ,  
 //     
 If not CanReadWriteAccess then begin
  HidHandle:= CreateFile(PChar(@HidName[1]),
               0,
               FILE_SHARE_READ or FILE_SHARE_WRITE,
               nil,
               OPEN_EXISTING, 0, 0
  );
 End else begin
  lbLog.Items.Add('     read/write');
 End;

 //    -   
 If HidHandle = INVALID_HANDLE_VALUE then begin
  lbLog.Items.Add('   ');
  Exit;
 End else begin
  lbLog.Items.Add('     read only!');
 End;

 //   
 Attributes.Size := SizeOf(THIDDAttributes);
 If HidD_GetAttributes(HidHandle, Attributes) then begin
  lbLog.Items.Add(Format('   VendorID=%d, ProductID=%d, VersionNumber=%d',[Attributes.VendorID, Attributes.ProductID, Attributes.VersionNumber]));
 End else begin
  lbLog.Items.Add('  HidD_GetAttributes');
 End;

 //   
 If HidD_GetNumInputBuffers(HidHandle, NumInputBuffers) then begin
  lbLog.Items.Add(Format('     =%d',[NumInputBuffers]));
 End else begin
  lbLog.Items.Add('  HidD_GetNumInputBuffers');
 End;

 //   
 FillChar(Buffer, SizeOf(Buffer), #0);
 If HidD_GetManufacturerString(HidHandle, Buffer, SizeOf(Buffer)) then begin
  lbLog.Items.Add(Format('   =%s',[Buffer]));
 End else begin
  lbLog.Items.Add('  HidD_GetManufacturerString');
 End;

 //   
 FillChar(Buffer, SizeOf(Buffer), #0);
 If HidD_GetProductString(HidHandle, Buffer, SizeOf(Buffer)) then begin
  lbLog.Items.Add(Format('   =%s',[Buffer]));
 End else begin
  lbLog.Items.Add('  HidD_GetProductString');
 End;

 //   
 FillChar(Buffer, SizeOf(Buffer), #0);
 If HidD_GetSerialNumberString(HidHandle, Buffer, SizeOf(Buffer)) then begin
  lbLog.Items.Add(Format('    =%s',[Buffer]));
 End else begin
  lbLog.Items.Add('  HidD_GetSerialNumberString');
 End;

 //   
 CloseHandle(HidHandle);
end;

end.
 