Uses PCI, StrFunc;

Procedure DetectUSBController;
var
    DeviceID, VendorID : Word;
    Description : String;
    IDIndex     : Integer;
    DevIndex    : Word;
    BusNumber, DevFuncNumber : Byte;
    Found       : Boolean;
begin
  IDIndex:=0;
  Repeat
   Case IDIndex of
     0: begin DeviceId:=$7020; VendorId:=$8086; Description:='Intel 82371SB USB controller'; end;
     1: begin DeviceId:=$7112; VendorId:=$8086; Description:='Intel PIIX4 USB controller'; end;
     2: begin DeviceId:=$3104; VendorId:=$1106; Description:='VIA AMD-645 EHCI USB v2'; end;
     3: begin DeviceId:=$3038; VendorId:=$1106; Description:='VIA AMD-645 UHC USB'; end;
     4: begin DeviceId:=$A0F8; VendorID:=$1045; Description:='Opti 82C750 (Vendetta) USB controller'; end;
     5: begin DeviceId:=$C861; VendorID:=$1045; Description:='Opti 82C861/871 (Firelink/FireBlast) USB controller'; end;
     Else IDIndex:= -1;
   End;

   If IDIndex = -1 then Break;

   DevIndex:= 0;
   Repeat
    Found:= DetectPCIDevice(DeviceId, VendorId, DevIndex, BusNumber, DevFuncNumber) = 0;
    If Found then begin
     Writeln(DevIndex, ':', Description);
     Writeln(' DeviceID      : ', Long2Hex(DeviceId));
     Writeln(' VendorID      : ', Long2Hex(VendorId));
     Writeln(' BusNumber     : ', BusNumber    );
     Writeln(' DevFuncNumber : ', DevFuncNumber);
    End;
    Inc(DevIndex);
   Until not(Found);

   Inc(IDIndex);
  Until (False);
end;

Begin
 If DetectPCIBios then begin
  WriteLn('PICBIOS ন');
 End else begin
  WriteLn('PICBIOS  ন');
  Exit;
 End;

 DetectUSBController;
End.