unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DrvLoader, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    btnLoad: TButton;
    btnUnload: TButton;
    Bevel1: TBevel;
    btnOpen: TButton;
    btnClose: TButton;
    Bevel2: TBevel;
    seInput: TSpinEdit;
    btnFunc1: TButton;
    btnFunc2: TButton;
    Label1: TLabel;
    EOutput: TEdit;
    procedure btnLoadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnUnloadClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnFunc1Click(Sender: TObject);
    procedure btnFunc2Click(Sender: TObject);
  private
  public
    Driver : TDriverLoader;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{  TDriverLoader}
procedure TForm1.FormCreate(Sender: TObject);
begin
 Driver:= TDriverLoader.Create;
end;

{  TDriverLoader}
procedure TForm1.FormDestroy(Sender: TObject);
begin
 Driver.Free;
end;

{     }
procedure TForm1.btnLoadClick(Sender: TObject);
begin
 Driver.CreateService(ExtractFilePath(ParamStr(0)));
 Driver.StartService;
end;

{     }
procedure TForm1.btnUnloadClick(Sender: TObject);
begin
 Driver.StopService;
 Driver.RemoveService;
end;

procedure TForm1.btnOpenClick(Sender: TObject);
begin
 If Driver.Open
  then MessageDlg('  ', mtConfirmation, [mbOK], 0)
  else MessageDlg('  ', mtError, [mbOK], 0);
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
 Driver.Close;
end;

procedure TForm1.btnFunc1Click(Sender: TObject);
begin
 EOutput.Text:= Format('=%d',[Driver.Func1(seInput.Value)]);
end;

procedure TForm1.btnFunc2Click(Sender: TObject);
begin
 EOutput.Text:= Format('=%d',[Driver.Func2(seInput.Value)]);
end;

end.
